#!/usr/bin/env python

import xlrd
import pprint

#print ("Hello world.")

#xlrd.open_workbook()にExcelファイルのパスを指定してBookオブジェクトを取得。
#sheet_names()メソッドでシート名一覧のリストを取得できる。
wb = xlrd.open_workbook('sample.xlsx')
#print(type(wb))
# <class 'xlrd.book.Book'>
#print(wb.sheet_names())
# ['sheet1', 'sheet2']


#Bookオブジェクトのメソッドsheets()でSheetオブジェクトのリストを取得。
#sheets = wb.sheets()
#print(type(sheets))
# <class 'list'>
#print(type(sheets[0]))
# <class 'xlrd.sheet.Sheet'>


#sheet_by_index()にシート番号、または、sheet_by_name()に
#シート名を指定して特定のシートのみを取得することも可能。
sheet = wb.sheet_by_name('sheet1')
#print(type(sheet))
# <class 'xlrd.sheet.Sheet'>


#Sheetオブジェクトのメソッドcell()に0始まりの行番号・列番号を指定して
#Cellオブジェクトを取得。Cellオブジェクトの属性valueでそのセルの値を取得できる。
#cell = sheet.cell(1, 2)
#print(cell)
# number:12.0
#print(type(cell))
# <class 'xlrd.sheet.Cell'>
#print(cell.value)
# 12.0


#Sheetオブジェクトのメソッドcell_value()でセルの値を直接取得することも可能。
#print(sheet.cell_value(1, 2))
# 12.0


#Sheetオブジェクトのメソッドcol()は列番号を指定して
#その列のCellオブジェクトのリストを返す。
#col = sheet.col(1)
#print(col)
# [text:'A', number:11.0, number:21.0, number:31.0]
#print(type(col[0]))
# <class 'xlrd.sheet.Cell'>


#col_values()でセルの値のリストを直接取得することも可能。
#col_values = sheet.col_values(1)
#print(col_values)
# ['A', 11.0, 21.0, 31.0]


#行番号を指定して行のCellオブジェクトのリスト、
#または、セルの値のリストを取得するrow(), row_values()メソッドもある。
#print(sheet.row_values(1))
# ['one', 11.0, 12.0, 13.0]


#リスト内包表記で各行の値をrow_values()メソッドで取得すると、
#セルの値を2次元配列（リストのリスト）として取得できる。
#pprint.pprint([sheet.row_values(x) for x in range(4)])
# [['', 'A', 'B', 'C'],
#  ['one', 11.0, 12.0, 13.0],
#  ['two', 21.0, 22.0, 23.0],
#  ['three', 31.0, 32.0, 33.0]]

#def get_list_2d(sheet, start_row, end_row, start_col, end_col):
#    return [sheet.row_values(row, start_col, end_col + 1) for row in range(start_row, end_row + 1)]


#row_values()メソッドには取得する列の始まりと終わりを引数で指定できる。
#0始まりの行番号・列番号で範囲を指定して2次元配列（リストのリスト）として取得する関数は以下のように定義できる。
#l_2d = get_list_2d(sheet, 2, 3, 1, 2)
#print(l_2d)
# [[21.0, 22.0], [31.0, 32.0]]


#ワークシートの行数はSheetオブジェクトの属性nrowsで取得できるので、
#ワークシート全体の値を2次元配列（リストのリスト）として取得する関数は以下のように定義できる。
print(sheet.nrows)
# 4

def get_list_2d_all(sheet):
    return [sheet.row_values(row) for row in range(sheet.nrows)]

l_2d_all = get_list_2d_all(sheet)
pprint.pprint(l_2d_all)
# [['', 'A', 'B', 'C'],
#  ['one', 11.0, 12.0, 13.0],
#  ['two', 21.0, 22.0, 23.0],
#  ['three', 31.0, 32.0, 33.0]]

print(l_2d_all[1][0])
# one
